/*
 * deviced
 *
 * Copyright (c) 2012 - 2013 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef __POWER_SUPPLY_H__
#define __POWER_SUPPLY_H__

#define CHARGER_TYPE_SIGNAL        "ChargerType"

enum device_change_type {
	DEVICE_CHANGE_ABNORMAL,
	DEVICE_CHANGE_NORMAL,
};

enum charge_status_type {
	CHARGE_STATUS_UNKNOWN,
	CHARGE_STATUS_DISCONNECTED,
	CHARGE_STATUS_CONNECTED,
	CHARGE_STATUS_CHARGING,
	CHARGE_STATUS_DISCHARGING,
	CHARGE_STATUS_NOT_CHARGING,
	CHARGE_STATUS_FULL,
};

enum charge_full_type {
	CHARGING_NOT_FULL,
	CHARGING_FULL,
};

enum charge_now_type {
	CHARGER_ABNORMAL	= -1,
	CHARGER_DISCHARGING,
	CHARGER_CHARGING,
};

enum health_type {
	HEALTH_NO_OPT = -1,
	HEALTH_GOOD,
	HEALTH_LOW,
	HEALTH_DEAD,
	HEALTH_HIGH,
	HEALTH_OVP,
};

enum present_type {
	PRESENT_ABNORMAL,
	PRESENT_NORMAL,
};

enum misc_type {
	MISC_NONE,
	MISC_MOISTURE,
};

enum battery_noti_type {
	DEVICE_NOTI_BATT_CHARGE,
	DEVICE_NOTI_BATT_LOW,
	DEVICE_NOTI_BATT_FULL,
	DEVICE_NOTI_MAX,
};

enum battery_noti_status {
	DEVICE_NOTI_OFF,
	DEVICE_NOTI_ON,
};

enum charger_charging_status {
	CHARGER_DISABLED,
	CHARGER_ENABLED,
};

struct battery_status {
	int capacity;
	int charge_status;
	int charge_full;
	int charge_now;
	int health;
	int present;
	int voltage_now;
	int voltage_average;
	int online;
	int online_type;
	int temperature;
	int current_now;
	int current_average;
	int charging_level;
	int charger_charging;
	int misc;
	char status_s[32];
	char health_s[32];
	char power_source_s[32];
};

struct battery_status battery;
struct battery_status old_battery;

int power_supply_broadcast(char *sig, int status);

#define CHARGER_STATUS_SIGNAL      "ChargerStatus"
#define CHARGE_NOW_SIGNAL          "ChargeNow"
#define CHARGE_LEVEL_SIGNAL        "BatteryStatusLow"
#define CHARGE_CAPACITY_SIGNAL     "GetPercent"
#define CHARGE_CAPACITY_LAW_SIGNAL "GetPercentRaw"
#define CHARGE_HEALTH_SIGNAL       "GetHealth"
#define CHARGE_FULL_SIGNAL         "IsFull"
#define CHARGE_BATTERY_PROPERTIES   "BatteryProperties"
#define CHARGE_MISC_EVENT_SIGNAL    "MiscEvent"

#endif /* __POWER_SUPPLY_H__ */
